<HTML>
<HEAD>
  <META NAME="GENERATOR" CONTENT="Adobe PageMill 3.0 Win">
  <TITLE>Ambient Compiler Parser</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H2>CS237c: Ambient Compiler Parser</H2>

<P>This is a standard parser implemented using <TT>ocamlyacc</TT>
and <TT>ocamllex</TT>. The result of parsing is an abstract syntax
tree. There are several kinds of sentences. The types <TT>var</TT>,
<TT>ty_var</TT>, etc. are variable names. The types <TT>ty_name</TT>,
<TT>mod_name</TT>, etc. are fully-qualified variables names (e.g.
<TT>Module.var</TT>). The type <TT>loc</TT> defines source code
locations, including the filename and location in the file.</P>

<P><B>Types: </B>are the usual products, unions, functions, etc.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> ty =
   TyInt of loc
 | TyChar of loc
 | TyString of loc
 | TyFun of ty * ty * loc
 | TyProd of ty list * loc
 | TyRecord of (bool * var * ty) list * loc
 | TyUnion of (var * ty list) list * loc
 | TyArray of ty * loc
 | TyApply of ty_name * ty list * loc
   (* Variables *)
 | TyParam of var * loc</PRE>
</BLOCKQUOTE>

<P><B>Patterns:</B> are patter-matching expressions.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> patt =
   PattInt of int * loc
 | PattChar of char * loc
 | PattString of string * loc
 | PattWild of loc
 | PattVar of var * loc
 | PattTuple of patt list * loc
 | PattRecord of (label_name * patt) list * loc
 | PattArray of patt list * loc
 | PattConst of const_name * patt list * loc
 | PattChoice of patt * patt * loc
 | PattAs of patt * patt * loc
 | PattConstrain of patt * ty * loc
 | PattWrap of patt * loc</PRE>
</BLOCKQUOTE>

<P><B>Expressions:</B> there are many expressions. Don't get scared,
the intermediate code is a lot simpler.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> exp =
   <I>(* Lambda calculus *)</I>
   Number of int * loc
 | Char of char * loc
 | String of string * loc
 | Var of var_name * loc
 | Const of const_name * loc
 | Unop of unop * exp * loc
 | Binop of binop * exp * exp * loc
 | Apply of exp * exp list * loc
 | Lambda of patt list * exp * loc
 | Function of guarded * loc
 | Let of lets * exp * loc
 | Funs of funs * exp * loc
 | If of exp * exp * exp * loc
 | Constrain of exp * ty * loc
 | Wrap of exp * loc

   <I>(* Aggregates *)</I>
 | Tuple of exp list * loc
 | Array of exp list * loc
 | ArraySubscript of exp * exp * loc
 | ArrayAssign of exp * exp * exp * loc
 | StringSubscript of exp * exp * loc
 | StringAssign of exp * exp * exp * loc
 | Record of record_item list * loc
 | RecordProj of exp * label_name * loc
 | RecordAssign of exp * label_name * exp * loc

   <I>(* Sequential execution *)</I>
 | Sequence of exp * exp * loc

   <I>(* Control flow *)</I>
 | Match of exp * guarded * loc
 | Try of exp * guarded * loc
 | CallCC of var * exp * loc

   <I>(* Ambient calculus *)</I>
 | In of mod_name * loc
 | Out of mod_name * loc
 | Open of mod_name * loc
 | Action of exp list * loc
 | Restrict of var * module_type * exp * loc
 | Ambient of var * module_exp * loc
 | Thread of exp * loc
 | Migrate of exp * exp * loc
 | LetModule of var * module_exp * exp * loc

<I>(* Info for a record creation *)</I>
<B>and</B> record_item = label_name * exp * loc

<I>(* Variable definitions *)</I>
<B>and</B> lets = (patt * exp) list

<I>(* Function definitions *)</I>
<B>and</B> funs = (var * patt list * exp) list

<I>(* Type definitions *)</I>
<B>and</B> types = (var * var list * ty * loc) list

<I>(* Guarded commands *)</I>
<B>and</B> guarded = (patt * exp) list</PRE>
</BLOCKQUOTE>

<P><B>Structure items:</B> are definitions that can be defined
in a module (between <B><TT>struct</TT></B><TT> ... <B>end</B></TT>).</P>

<BLOCKQUOTE>
  <PRE><B>type</B> str_item =
   StrItemLet of lets * loc
 | StrItemFuns of funs * loc
 | StrItemExpr of exp * loc
 | StrItemRestrict of var * module_type * loc
 | StrItemType of types * loc
 | StrItemModule of var * module_exp * loc
 | StrItemModuleType of var * module_type * loc</PRE>
</BLOCKQUOTE>

<P><B>Signature items:</B> are <I>declarations</I> that can occur
in a module signature.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> sig_item =
   SigItemType of types * loc
 | SigItemVal of var * ty * loc
 | SigItemModuleType of var * module_type * loc</PRE>
</BLOCKQUOTE>

<P><B>Modules (and ambients):</B> are collections of structure
items.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> module_exp =
   ModuleExpStruct of str_item list * loc
 | ModuleExpVar of mod_name * loc
 | ModuleExpConstrain of module_exp * module_type * loc</PRE>
</BLOCKQUOTE>

<P><B>Module types (and ambient types):</B> are lists of declarations.</P>

<BLOCKQUOTE>
  <PRE><B>type</B> module_type =
   ModuleTypeSig of sig_item list * loc
 | ModuleTypeVar of mod_type_name * loc
 | ModuleTypeWithType of module_type * ty_name * var list * ty * loc
 | ModuleTypeWithModule of module_type * mod_name * mod_name * loc</PRE>
</BLOCKQUOTE>

</BODY>
</HTML>
